<template>
    <div class="modal">
        <div class="modal-mask"></div> 
        <button class="close-btn button-icon" @click="closeModal();">
            <i class="icon-close"></i>
        </button>
        <div class="modal-wrapper">
            <div class="modal-sidebar">
                <div>
                    <h2 v-if="isEditMode">Edit <br>Data <br>Product</h2>
                    <h2 v-else>Create <br>Data <br>Product</h2>
                    <div>
                        <nav>
                            <ul>
                                <li :class="{ 'active': currentStep === 1 }"><div><span>1</span>Data Product Info</div></li>
                                <li :class="{ 'active': currentStep === 2 }"><div><span>2</span>Data Product Policy</div></li>
                                <li :class="{ 'active': currentStep === 3 }"><div><span>3</span>Data Product Types</div></li>
                                <li :class="{ 'active': currentStep === 4 }"><div><span>4</span>confirmation</div></li>
                            </ul>
                        </nav>
                    </div>
                </div>
                <div>
                    <div class="info user">
                        <h3>Owner</h3>
                        <UserProfile />
                    </div>
                    <InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
                </div>
            </div>
            <div class="modal-content">
                <!-- ==== STEP 1 - Data product Info ====  -->
                <div id="step-1" class="step" v-show="currentStep === 1">
                    <form id="data-product-step-1" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">1</span>
                            <h2>Data Prodcut Info</h2>
                            <p>You can create new datasets using either the Bulk or Streaming method.<br>Choose the option that best suits your needs and get started now!</p>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>1.</span>Domain name</label>
                                <input type="text" name="name" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>2.</span>Legal Participant URL</label>
                                <input type="text" name="legal-participant" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>3.</span>Data product name</label>
                                <input type="text" name="data-product-name" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>4.</span>Data product description</label>
                                <input type="text" name="data-product-decription" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>5.</span>Data product terms and conditions URL</label>
                                <input type="text" name="data-product-terms-url" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                    </form>
                </div>

                <!-- ==== STEP 2 - Data product policy === -->
                <div id="step-2" class="step" v-show="currentStep === 2">
                    <form id="data-product-step-2" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">2</span>
                        <h2>Data Product Info</h2>
                        <p>You can create new datasets using either the Bulk or Streaming method.<br>Choose the option that best suits your needs and get started now!</p>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>6.</span>Legal Registration Type</label>
                                <CustomSelect class="col" :options="legalRegistratrionType" defaultTitle="Select a type" name="legal-registratrion-type" />
                            </div>
                        </div>
                        <button class="button-secondary orange">Create Policy</button>
                    </form>
                </div>

                <!-- ==== STEP 2 - Data product types === -->
                <div id="step-3" class="step" v-show="currentStep === 3">
                    <form id="data-product-step-3" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">3</span>
                            <h2>Data Product Types</h2>
                            <p>You can create new datasets using either the Bulk or Streaming method.<br>Choose the option that best suits your needs and get started now!</p>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <div class="label-parent"><span>7.</span>Data Account Info</div>
                                <div class="modal-boxs-wrapper modal-2-col">
                                    <div class="modal-input col">
                                        <label for="" class="label-select"><span>7.1</span>Request type</label>
                                        <CustomSelect class="col" :options="requestType" defaultTitle="Select a type" name="request-type" />
                                    </div>
                                    <div class="modal-input col">
                                        <label for="" class="label-select"><span>7.2</span>Access type</label>
                                        <CustomSelect class="col" :options="accessType" defaultTitle="Select a type" name="access-type" />
                                    </div>
                                    <div class="modal-input col">
                                        <label for="" class="label-select"><span>7.3</span>Format type</label>
                                        <CustomSelect class="col" :options="formatType" defaultTitle="Select a type" name="format-type" />
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <div class="label-parent"><span>8.</span>Data Resources Info</div>
                                <label for="" class="label"><span>8.1.</span>API endpoint URL</label>
                                <input type="text" name="api-url" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>8.2</span>Data resource name</label>
                                <input type="text" name="resource-name" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>8.3</span>Data resource description</label>
                                <input type="text" name="resource-description" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>8.4</span>Data resource licence</label>
                                <CustomSelect class="col" :options="resourceLicence" defaultTitle="Select a licence" name="resource" />
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>8.5</span>Data resource copyright</label>
                                <input type="text" name="resource-copyright" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32" />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                    </form>
                </div>

                <!-- ==== STEP 4 - Confirmation === -->
                <div id="step-4" class="step" v-show="currentStep === 4">
                    <div class="title">
                        <span class="step-number">2</span>
                        <h2>Confirmation</h2>
                        <p>Your data product has been created. Please review the details below to confirm everything is correct.</p>
                    </div>
                    <div class="confirmation-wrapper">
                        <div class="confirmation-wrapper-values">
                            <div class="card-values">
                                <div class="card-values-number">2</div>
                                <div class="card-values-text">Domains</div>
                            </div>
                        </div>
                        <button class="button-secondary orange" @click="closeModal">Confirm Details</button>
                    </div>
                </div>

            </div>
            <div class="modal-buttons-area">
                <button :class="['button-stroke-transparent rounded', currentStep === 1 && 'hide']" id="previous-step"
                    @click="previousStep">Back</button>
                <button class="button-secondary orange" id="next-step" @click="handleNextClick">
                    <span v-if="currentStep === 4">Create</span>
                    <span v-else>Next</span>
                </button>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">

const props = defineProps({
    row: { 
        type: undefined as any, 
        required: false 
    },
    isEditMode: {
        type: Boolean,
        required: false
    }
});

const emit = defineEmits(['toggle', 'refresh-data']);

const closeModal = () => {
    emit('toggle');
    emit('refresh-data');
}

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);
const close = () => {
    showFeedback.value = false;
};

const legalRegistratrionType = [
    { id: 1, name: 'TimeIntervalPolicy' },
    { id: 2, name: 'vatID' },
    { id: 3, name: 'leiCode' },
    { id: 4, name: 'EORI' }
];

const requestType = [
    { id: 1, name: 'API' },
    { id: 2, name: 'vatID' },
    { id: 3, name: 'leiCode' },
    { id: 4, name: 'EORI' }
];

const accessType = [
    { id: 1, name: 'Digital' },
    { id: 2, name: 'vatID' },
    { id: 3, name: 'leiCode' },
    { id: 4, name: 'EORI' }
];

const formatType = [
    { id: 1, name: 'Application/Json' },
    { id: 2, name: 'vatID' },
    { id: 3, name: 'leiCode' },
    { id: 4, name: 'EORI' }
];

const resourceLicence = [
    { id: 1, name: 'EPL-2.0' },
    { id: 2, name: 'vatID' },
    { id: 3, name: 'leiCode' },
    { id: 4, name: 'EORI' }
];

const currentStep = ref<number>(1);

// form submit step 1
const handleSubmit = () => {
    
}

const handleNextClick = () => {
    nextStep();
}

const nextStep = () => {
    if (currentStep.value < 4) {
        currentStep.value++;
    }
}

const previousStep = () => {
    if (currentStep.value > 0) {
        currentStep.value--;
    }
}

</script>